<template>
 <div class="app">
    <vue-headful
            title="Registrate en needoc"
            description="Página de registro needoc"
        />
        
      <section class="container margin-bot6">

        <div class="title item">
          <h1>Estás a punto de formar parte de la familia needoc</h1>
          <hr class="head-hr">
          <p class="slogan">La comunidad de médicos on-line más grande de España</p>
        </div>

        <div class="container-form item">

          <form @submit="checkForm">
            <ul class="userandpatient">
              <li>
                <label class="slogan" for="normal">
                  <img src="../assets/images/icons/ico-patient.png" class="ico-typeuser">
                <br>
                Paciente</label>
                <br>
                <input type="radio" v-model="role" id="normal" value="normal">   
              </li>
              <li>
                <label  class="slogan"  for="doctor">
                  <img src="../assets/images/icons/ico-doctor.png" class="ico-typeuser">
                <br>
                Doctor</label>
                <br>
                <input type="radio" v-model="role" id="doctor"  value="doctor">
              </li>
            </ul>

              <!-- <md-switch v-model="role">{{ !role ? 'normal' : 'doctor' }} Errors</md-switch> -->
                
            <!-- inicio datos compartidos usuario/doctor  -->

            <div class="spacer"  v-if="role == 'normal' || role == 'doctor'" >

              <h3>
                Me quiero registrar como 
                <span  v-if="role == 'normal'" class="color-prime">Paciente</span>
                <span  v-if="role == 'doctor'" class="color-prime">Doctor</span>
              </h3>

              <br>
              <ul>
                <li>
                  <label class="lab-width">Nombre:</label>
                  <input type="text" v-model="name" placeholder="Nombre">
                </li>
                <li>
                  <label class="lab-width">Apellido:</label>
                  <input type="text" v-model="surname" placeholder="Usuario">
                </li>
                <li>
                  <label class="lab-width">Email:</label>
                  <input type="email" v-model="email" placeholder="Email">
                </li>
                <li>
                  <label class="lab-width">Contraseña:</label>
                  <input type="password" v-model="password" placeholder="Contraseña">
                </li>
                <li>
                  <label class="lab-width">Repetir Contraseña:</label>
                  <input type="password" v-model="passwordRepeat" placeholder="Contraseña">
                </li>
                <li>
                  <label class="lab-width">Fecha de nacimiento:</label>
                  <input type="date" id="age" v-model="age" placeholder="Edad">
                </li>
              </ul>
              <!-- solo datos para usuario Paciente -->
              <div v-if="role == 'normal'">
                <hr>
                <ul>
                  <li>
                      <label class="lab-width">Pack a elegir:</label>
                      <select type="text" v-model="packtype"  placeholder="Pack">
                          <option value="Alta">Pack Gold Pro + VideoChat</option>
                          <option value="Media">Pack Silver</option>
                          <option value="Baja">Pack Basic</option>
                      </select>
                  </li>
                  <li>
                      <label class="lab-width">Número de Póliza:</label>
                      <input type="text" v-model="policy_number" max="16">
                  </li>
                  <li>
                      <label class="lab-width">Tu compañía de Seguros:</label>
                      <select type="text" v-model="insurance_company"  placeholder="Aseguradora">
                          <option value="Antares">Antares</option>
                          <option value="Caser">Caser</option>
                          <option value="Cigna Life">Cigna Life</option>
                          <option value="Fiatc">Fiatc</option>
                          <option value="Helvetia">Helvetia</option>
                          <option value="Mapfre Caja Salud">Mapfre Caja Salud</option>
                          <option value="Nectar">Nectar</option>
                          <option value="Sanitas">Sanitas</option>
                      </select>
                  </li>
                </ul>
                <hr>
              </div>

              <!-- inicio datos exclusivos del doctor  -->

              <div v-if="role == 'doctor'">
                <ul>
                  <li>
                    <label class="lab-width">Avatar:</label>
                    <input type="text" v-model="avatar" placeholder="Imagen de perfil">
                  </li>
                  <li>
                    <label class="lab-width">Años de experiencia:</label>
                    <input type="date" v-model="yearsExperience" placeholder="Experienca">
                  </li>
                  <li class="available-input margin-top0875 margin-bot0875 ">
                    <label class="lab-width">Disponibilidad:</label>
                    <input type="radio" v-model="available" value="Alta"> Alta | 
                    <input type="radio" v-model="available" value="Media"> Media | 
                    <input type="radio" v-model="available" value="Baja"> Baja
                  </li>
                  <li>
                    <label class="lab-width">Número de colegiado:</label>
                    <input type="text" v-model="collegiatenumber" maxlength="9" size="9">
                  </li>
                  <li>
                    <label class="lab-width">Selecciona Grupo de Especialidad:</label>
                    <select type="text" v-model="valueSpecialtyGroup" placeholder="Specialty Group">
                      <option disabled  value="">Selecciona grupo de especialidad</option>
                      <option value="Clínica">Clínica</option>
                      <option value="Quirúrgicas">Quirúrgicas</option>
                      <option value="Médico quirúrgicas">Médico-quirúrgicas</option>
                      <option value="Laboratorio o diagnósticas">Laboratorio o diagnósticas</option>
                    </select>
                  </li>
                  <li>
                    <div  v-if="valueSpecialtyGroup == 'Clínica' || 'Quirúrgicas' || 'Médico quirúrgicas' || 'Laboratorio o diagnósticas'" >
                        <label class="lab-width"  v-if="valueSpecialtyGroup.length > 0" >
                          Selecciona especialidad:
                        </label>
                        <!-- ESPECIALIDAD CLÍNICA -->
                          <select type="text" v-model="valueSpecialty"  v-if="valueSpecialtyGroup == 'Clínica'" placeholder="Specialty Group">
                            <option disabled value="">Selecciona especialidad clínica</option>
                            <option value="Alergología">Alergología</option>
                            <option value="Anestesiología">Anestesiología</option>
                            <option value="Angiología">Angiología</option>
                            <option value="Cardiología">Cardiología</option>
                            <option value="Endocrinología">Endocrinología</option>
                            <option value="Epidemiología">Epidemiología</option>
                            <option value="Gastroenterología">Gastroenterología</option>
                            <option value="Geriatría">Geriatría</option>
                            <option value="Hematología">Hematología</option>
                            <option value="Hepatología">Hepatología</option>
                            <option value="Infectología">Infectología</option>
                            <option value="Medicina aeroespacial">Medicina aeroespacial</option>
                            <option value="Medicina del deporte<">Medicina del deporte</option>
                            <option value="Medicina de emergencia">Medicina de emergencia</option>
                            <option value="Medicina familiar y comunitaria">Medicina familiar y comunitaria</option>
                            <option value="Medicina física y rehabilitación">Medicina física y rehabilitación</option>
                            <option value="Medicina forense">Medicina forense</option>
                            <option value="Medicina intensiva">Medicina intensiva</option>
                            <option value="Medicina interna">Medicina interna</option>
                            <option value="Medicina preventiva y salud pública">Medicina preventiva y salud pública</option>
                            <option value="Medicina del trabajo">Medicina del trabajo</option>
                            <option value="Nefrología">Nefrología</option>
                            <option value="Neumología">Neumología</option>
                            <option value="Neurología">Neurología</option>
                            <option value="Nutriología">Nutriología</option>
                            <option value="Oncología médica">Oncología médica</option>
                            <option value="Oncología radioterápica">Oncología radioterápica</option>
                            <option value="Pediatría">Pediatría</option>
                            <option value="Psiquiatría">Psiquiatría</option>
                            <option value="Reumatología">Reumatología</option>
                            <option value="Toxicología">Toxicología</option>
                          </select>

                        <!-- ESPECIALIDAD QUIRÚRGICA -->
                          <select type="text" v-model="valueSpecialty" v-if="valueSpecialtyGroup == 'Quirúrgicas'" placeholder="Specialty Group">
                            <option disabled value="">Selecciona especialidad quirúrgica</option>
                            <option value="Cirugía cardíaca">Cirugía cardíaca</option>
                            <option value="Cirugía general">Cirugía general</option>
                            <option value="Cirugía oral y maxilofacial">Cirugía oral y maxilofacial</option>
                            <option value="Cirugía ortopédica">Cirugía ortopédica</option>
                            <option value="Cirugía pediátrica">Cirugía pediátrica</option>
                            <option value="Cirugía plástica">Cirugía plástica</option>
                            <option value="Cirugía torácica">Cirugía torácica</option>
                            <option value="Cirugía vascular">Cirugía vascular</option>
                            <option value="Neurocirugía">Neurocirugía</option>
                          </select>

                        <!-- ESPECIALIDAD Médico-quirúrgicas -->
                          <select type="text" v-model="valueSpecialty"   v-if="valueSpecialtyGroup == 'Médico quirúrgicas'" placeholder="Specialty Group">
                            <option disabled value="">Selecciona especialidad Médico-quirúrgicas</option>
                            <option value="Dermatología">Dermatología</option>
                            <option value="Ginecología y obstetricia o tocología">Ginecología y obstetricia o tocología</option>
                            <option value="Oftalmología">Oftalmología</option>
                            <option value="Otorrinolaringología">Otorrinolaringología</option>
                            <option value="Traumatología">Traumatología</option>
                            <option value="Urología">Urología</option>
                          </select>

                        <!-- ESPECIALIDAD CLINICA -->
                          <select type="text" v-model="valueSpecialty"   v-if="valueSpecialtyGroup == 'Laboratorio o diagnósticas'" placeholder="Specialty Group">
                            <option disabled value="">Selecciona especialidad Laboratorio o diagnóstica</option>
                            <option value="Análisis clínico">Análisis clínico</option>
                            <option value="Anatomía patológica">Anatomía patológica</option>
                            <option value="Bioquímica clínica">Bioquímica clínica</option>
                            <option value="Farmacología">Farmacología</option>
                            <option value="Fisioterapia">Fisioterapia</option>
                            <option value="Genética médica">Genética médica</option>
                            <option value="Inmunología">Inmunología</option>
                            <option value="Medicina nuclear">Medicina nuclear</option>
                            <option value="Microbiología y parasitología">Microbiología y parasitología</option>
                            <option value="Neurofisiología clínica">Neurofisiología clínica</option>
                            <option value="Radiología">Radiología</option>
                          </select>
                          
                    </div>
                  </li>
                </ul> 
              </div>

              <!-- fin datos exclusivos del doctor  -->

                        
                <div v-if="errors.length > 0" class="warning-msg">
                    <i class="fa fa-warning"></i>
                    <b> {{errorBack}} </b>


                    <!--  inicio validación de errores -->
                    <p v-if="errors.length">
                      <b>Parece que te faltan por cubrir los siguientes datos:</b>
                      <ul>
                        <li v-for="error in errors" :key="error.index"> {{ error }}</li>
                      </ul>
                    </p>
                    <!-- fin validación de errores -->

                </div>




                   

             
              <button class="button-prime">Registrarme</button>

            </div>
            <!-- fin datos compartidos usuario/doctor  -->
          </form>

        </div>
      
      </section>
  </div>
</template>

<script>
import axios from 'axios';
import Swal from 'sweetalert2';
import { library } from '@fortawesome/fontawesome-svg-core'
import { faUserSecret } from '@fortawesome/free-solid-svg-icons'

library.add(faUserSecret)

export default {
    name: 'Doctors',
//inicio Data
    data(){
      return{
        // muestra el formulario para de los pacientes y oculta el de los doctores
        // a traves de la directiva v-if  se pueden mostrar u ocutar campos (paciente / doctor)
        role: '',
        // muestra el la especialidad correspondiente al grupo de especialidad seleccionado
        valueSpecialtyGroup: '',
        valueSpecialty: '',


        // para la validacion
        errors:[],

        // inicialización campos texto
        name: null,
        surname: null,
        email: null,
        password: null,
        passwordRepeat: null,
        age: 0,
        // estos datos son exclusivos del doctor
        avatar: null,
        yearsExperience: '',
        available: null,
        collegiatenumber: null,
        // estos datos son exclusivos del paciente
        packtype:'',
        policy_number:'',
        insurance_company:'',

        // Si creatingUser es false los datos no se envian
        creatingUser: false,

        // error que venga de back
        errorBack:''
      }
    },
// FIN DATA
// inicio METHODS
  methods:{
    
     
    checkForm:function(e) {



      if(this.name && this.age && this.email && this.age && this.email) {

        this.creatingUser = true;
        this.addNewUser()

        return true
        };

      this.errors = [];

      // si soy doctor o paciente
      if(!this.name) this.errors.push("Nombre");
      if(!this.surname) this.errors.push("Apellidos");
      if(!this.age) this.errors.push("Edad");
      if(!this.email) this.errors.push("Email");
      if(this.password != this.passwordRepeat) this.errors.push("Las contraseñas no coinciden")

      // si soy paciente
      if(this.role == 'normal'){
        if(!this.packtype) this.errors.push("Selecciona el pack que se adapte a tus necesidades");
        if(!this.policy_number.length) this.errors.push("No te olvides de tu número de poliza");
        if(!this.insurance_company) this.errors.push("Acuérdate de tu compañia de seguros");
      }

      // si soy doctor
      if(this.role == 'doctor'){
        if(!this.available) this.errors.push("Disponibilidad");
        if(!this.valueSpecialtyGroup) this.errors.push("Grupo de especialidad");
        if(!this.specialty) this.errors.push("Especialidad");
        if(!this.yearsExperience) this.errors.push("Años de experiencia")
      }
      
      this.creatingUser = false; // no se envia al backend

      e.preventDefault();
    },
    validEmail: function (email) {
      
      var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      return re.test(email);
    },
    addNewUser(){
      
            if(this.creatingUser === true){ 
                var self = this;
                 console.log(this.role)

                axios.post('http://localhost:3050/user', {
                    role: self.role,
                    name: self.name,
                    surname: self.surname,
                    email: self.email,
                    password: self.password,
                    age: self.age,
                    yearsExperience: self.yearsExperience,
                    available: self.available,
                    avatar: self.avatar,
                    collegiatenumber: self.collegiatenumber,
                    specialtyGroup: self.valueSpecialtyGroup,
                    specialty: self.valueSpecialty,
                    packtype: self.packtype,
                    policy_number: self.policy_number,
                    insurance_company: self.insurance_company,

                })
                .then( function(response){
                    console.log(response)
                    // pasamos el error a errorBack en data()
                    self.errorBack = response.data.message
                    
                    console.log('response-->',response.data.status)

                    if(response.data.status == undefined){
                      //ventana sweetalert
                      Swal.fire({
                          title: 'Muchas gracias!!! ',
                          text: "por registrarte en needoc, en breve recibirás un correo de confirmación",
                          button: "Cerrar", // Text on button
                          // icon: "success", //built in icons: success, warning, error, info
                          timer: 3000 //timeOut for auto-close

                          
                      })

                      // poner ocultar campos
                      self.role = '',

                      //vaciar los campos
                      self.name = ''
                      self.surname = ''
                      self.email = ''
                      self.password = ''
                      self.passwordRepeat = '',
                      self.age = ''
                      self.avatar = ''
                      self.years_experience = '',
                      self.available = '',
                      self.collegiatenumber = ''
                      self.errorBack = '' 
                      self.valueSpecialty = ''
                      self.packtype = ''
                      self.policy_number = '',
                            

                      this.errors.length = 0;
                      
                     }


                      this.$router.push('/') 


                    
                })
                .catch( function(error){
                    console.log(error)
                })
                // una vez enviado el mensaje volvemos a poner la variable en false
                this.creatingClient = false;

                
            }else{
                console.log('Yo no debería estar aquí')
            }
        }
  }
// FIN METHODS
}
</script>

<style scoped>

h1 {
  padding-bottom: 1rem;
}

/* CONTENEDORES */

.container {
  display: flex;
  flex-direction: row;
  flex: 1;
  padding: 0 5rem;
  min-height: 60vh;
}

/* ITEMS CONTENERDORES */

.container-form {
      display: flex;
      flex-direction: column;
      flex: 1;
}

.title {
  padding: 0 100px 0 0;
  flex: 0.5;
}

/* ul li */

.userandpatient {
  display: flex;
  align-items: center;
  justify-content: center;
  }

.userandpatient > li {
  flex-direction: column;
  flex-grow: 1;
  padding: 0 1rem;
  text-align: center;
}

/* icon size */

.ico-typeuser {
  width: 150px;
  padding-bottom: 2rem;
}

/* label */
.lab-width {
  display: inline-block;
  width: var(--spacer-6);
}

/* disponibilidad li */

.available-input > input {

  display: inline-block;
  width: 16px;
}

/* hr */
/* hr {
    border: 1px solid var(--color-general-salmon);
} */
/* modal */
.swal2-confirm .swal2-styled {
        border-left-color: #5D5D5D !important;
        border-right-color: #5D5D5D !important;
    }

/* inicio linea con texto en medio */
  p.separatorline {
    font: 16px sans-serif;
    margin-top: 30px;
    text-align: center;
    background-color: none !important;
  }
  p.linea {
    position: relative;
    z-index: 1;
  }
  p.linea:before {
    border-top: 1px solid white;
    content: "";
    margin: 0 auto;
    position: absolute;
    top: 50%;
    left: 0;
    right: 0;
    bottom: 0;
    width: 95%;
    z-index: -1;
  }
  p.linea span {

    padding: 0 15px;
  }

.spacer {
  margin-left: 8rem;
}


   @media (max-width: 1170px) {
   
   .container {
      display: flex;
      flex-direction: column;
      flex: 1;
      padding: 0 5rem;
      min-height: 60vh;
    }
    .title {
      padding: 0;
      flex: 1;
    }
    .slogan {
      padding-bottom: 4rem;
    }
    .spacer {
      margin-left: 0rem;
    }
   }
  @media (max-width: 690px) {
   
   .container {
      padding: 0 1rem;
    }
  }

</style>